#!/usr/bin/perl
#
#               -------------
#		  Expirator
#               -------------
#
#         File: nph-expirator.cgi
#  Description: This library contains all procedures that allow administrators to 
#               automatically delete expired records an notify people via mail.
#               (needs $db_expire field value into database)
#       Author: Christian Leporati
#               via Medaglie d'oro 1 - I-41012 - Carpi (MO) - Italy
#        Email: lepo@web-linker.com
#          (c): alex@gossamer-threads.com 
#               this is a free impletentation that could be added to LINKS 1.1. 
#          Web: http://web-linker.com/lepolinks
#      Version: 0.995.c4
#
#
# COPYRIGHT NOTICE:
#
# This program is being distributed as "postcardware".  It may be used and
# modified so long as this copyright notice and the header above remain intact.
# Any use should be registered sending a postcard to Christian Leporati. 
# Please let me know where you are using this script. By using this program 
# you agree to indemnify Gossamer Threads Inc. and web-linker.com from any 
# liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain written permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# =====================================================================
#
# Required Librariers
# --------------------------------------------------------
eval {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");	# Get the script location: UNIX /
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");	# Get the script location: Windows \

    require "links.cfg";					# Change this to full path to links.cfg if you have problems.
    require "$db_lib_path/db.pl";           # Database Routines.
    require "$db_lib_path/site_html.pl";    # Get some HTML stuff we need.
    require "$db_lib_path/admin_html.pl";   # Get Admin HTML routines.
};
if ($@) {
    print "Content-type: text/plain\n\n";
    print "Error including libraries: $@\n";
    print "Make sure they exist, permissions are set properly, and paths are set correctly.";
	exit;
}

# =====================================================================
#
# TEMPLATE MESSAGES
# -----------------
#
$template_email_subject = qq|֪ͨ|;

$template_email_body    = qq|װ %%contact_name%%,
	ż֪ͨ"$site_title" ($build_root_url) ݿе¼:

	ID      : %%ID%%
	URL:    : %%url%%
	    : %%category%%
	:   : %%modified%% 

	    : %%hits%%
	new     : %%isnew%%
	pop     : %%ispop%%

Ѿڼڽ챻ɾ. ϵԱȡĽһϺαӵķ. 


Best Regards


Ա
$db_admin_email
$build_root_url
|;
# =====================================================================
#
#

eval { &main; };			    # Trap any fatal errors so the program hopefully 
if ($@) { &cgierr("fatal error: $@"); }     # never produces that nasty 500 server error page.
exit;   				    # There are only two exit calls in the script, here and in in &cgierr. 


sub main {
# --------------------------------------------------------
    $| = 1;		# Must flush output.
    $nph = 1;
    &html_print_headers;

    local($succstr, $errstr);
    local(%in)   = &parse_form;	# Get Form Results

       if ($in{'delete_records'} eq "1")  		{   &delete_records; 	}
    elsif ($in{'email_to_expired_records'} eq "1") 	{   &html_email_notification; 	}
     else   						{   &html_expire_form;		}
}


sub html_record_form_spreadsheet_expire {
# --------------------------------------------------------
# Displays a record in a one row format

	my (%rec)  = @_;
	my ($font) = qq|Font face="Verdana, Arial, Helvetica" Size=1 Color=#003399|;
	
	print qq|   
                 <td><$font>&nbsp;
        |;

	if (($rec{'URL'} ne 'NULL') && (length($rec{'URL'}) > 7))
				    { print qq| <strong><a href="$build_jump_url?$db_key=$rec{$db_key}">$rec{'Title'}</a></strong>|;}
                          else      { print qq| <strong>$rec{'Title'}</strong>|;}
        
	print qq|   
                 </font></td>
                 <td>   <$font>&nbsp;
         			$rec{'Date'}
   		 </font></td>
                 <td>   <$font>&nbsp;
         			$rec{'Expire'}
   		 </font></td>
       |;
}         



sub html_expire_form {
# --------------------------------------------------------
# search for expirated records
#
    my ($message) = @_;
    my (@hits, @num_days) = (); 
    my (@db_form_header_columns_expire) = ("", "", "ʱ", "");
    my ($numhits, $maxhits,$days, $i) = 0;


    open (DB, "<$db_file_name") or &cgierr("error in records. unable to open db file: $db_file_name. Reason: $!");
      @lines = <DB>;
    close DB;		
		
    LINE: foreach $line (@lines)
                {
		  if ($line =~ /^$/) { next LINE; }
		  if ($line =~ /^#/) { $output .= $line; next LINE; }
		  chomp ($line);
			
		  @rec = &split_decode($line);

  		  if (!$rec[$db_modified]) {
			print "!  (û!): $line\n";
			next LINE;
		  }

                  $days = &days_old($rec[$db_modified], $date);

		  if (($days > $rec[$db_expire]) && ($rec[$db_expire] > 0) ) {
		  	push(@hits, @rec); 
		  	push(@num_days, ($days - $rec[$db_expire]));
		  }

                }    

    $numhits = ($#hits+1) / ($#db_cols+1);
    $maxhits = $db_max_hits;
    $maxhits = $in{'mh'} if ($in{'mh'});
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>Expirator.</TITLE>
</HEAD>

<$site_body>
    <H2><TT>ڼ</TT></H2>
    <FORM ACTION="$db_dir_url/nph-expirator.cgi" METHOD="GET">
		<input type="hidden" name="db" value="$db_name">
|;

  print qq|<p><$font><font size=3 color=red>$message</font></font></p>| if ($message ne "");
 
# Go through each hit and convert the array to hash and send to 
# html_record for printing. Also add a checkbox with name=key and value=delete.

    if ($numhits < 1) {  # search returned 0
        print qq|<$font>ûзֹڵļ¼.</font>|;
    }
    else {
# Print Column Headers
	    if ($numhits == $maxhits) {
	        print qq|<P>ֽ϶Ĺڼ¼ֵ (<strong>$maxhits</strong>).
					 <A HREF="$db_search_next_url"> $maxhits</a> ?
					|;
	    }
	    else {
	        print qq|<P><$font>һ <strong>$numhits</strong> ڼ¼</font>:
			|;
	    }

	print qq|     <$font>ѡ¼ȻѡҪеĲٰȷ:</font>
			<TABLE BORDER=1 CELLPADDING=6 CELLSPACING=0>
			 <tr><td><strong><font face="verdana" size=1>$db_key</font></strong></td>
		|;
	
	foreach $col (@db_form_header_columns_expire) {
		print qq|<td><strong><font face="verdana" size=1>$col</font></strong></td>|;
	}
	print "</tr>";

# Print Main Body.		
        for ($i = 0; $i < $numhits; $i++) {
            %tmp = &array_to_hash ($i, @hits);
            print qq|<TR><TD valign=top width="100">
				<INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="delete"> 
				<font face="verdana" size=1>$tmp{$db_key}</font>
			 </TD>|;
            &html_record_form_spreadsheet_expire (%tmp);
            print qq|
		      <TD>&nbsp;
				  <$font>$num_days[$i] <$font>  
		      </TD>
		      </TR>
		    |;
        }
      print qq|    </TABLE>
		    <P> <INPUT TYPE="radio" NAME="delete_records" VALUE="1">              ɾѡļ¼ <br>
			<INPUT TYPE="radio" NAME="email_to_expired_records" VALUE="1">    EMAIL֪ͨѡļ¼ 
			( <INPUT TYPE="checkbox" NAME ="is_debug" VALUE ="yes" CHECKED>     ģʽ )<br>

	    <P>
              <table border=0>
              <tr><td valign="top">
              <$font><B>дҪ͵Ϣ</b>.<BR>
              ʹбǩʾ¼еϢ:<p>   
              <$font>
              %%ID%%            <BR>
              %%category%%      <BR>
              %%modified%%      <BR>
              %%url%%           <BR>
              %%hits%%          <BR>
              %%isnew%%         <BR>
              %%ispop%%         <BR>
              %%contact_name%%  <BR>
              %%contact_email%% <BR>
             </font>
             </td>
             <td>
             <$font><font color=blue></font></font><BR> 
             <INPUT TYPE="TEXT" NAME="message_to_email_subject" VALUE="$template_email_subject" SIZE="50" MAXLENGTH="100"><BR>
             <$font><font color=blue></font></font><BR> 
             <TEXTAREA NAME="message_to_email_body" ROWS="15" COLS="50" WRAP="VIRTUAL" MAXLENGTH="7000">$template_email_body</TEXTAREA>
             </td>
             </tr>
             </table>

		        <INPUT TYPE="SUBMIT" VALUE="     ȷ     "> 
			<INPUT TYPE="RESET" VALUE="">
	      |;
    }

print qq|
    </FORM>
       <p> <center><$font><a href="http://oh.yeah.net" target="_"><b>Oh Yeah Net</b></a></font></center>
</BODY>
</HTML>
|;

}

sub html_email_notification {
# --------------------------------------------------------
# email a notification email to selected people
#
	my (%email_listm, $succstr, $errstr);
	my ($line, @lines, $id, @rest, $output, $message_to_email_tmp);
	my ($rec_to_email) = 0;

	my ($time) = &get_time;
	my ($date) = &get_date;

        	foreach $key (keys %in) 		# Build a hash of keys to email.
                 {       if ($in{$key} eq "delete") 
                           {       $email_list{$key} = 1;
	          		   $rec_to_email = 1;
		           }
	         }

        	if (!$rec_to_email) 
                 {
		      &html_expire_form("You must mark at least one record.");
			exit;
   	         }	
                else 
                {

	print qq|
<html>
<head>
<title>Email Notification</title>
</head>
<$site_body>
    <$font><FONT SIZE=4>EMAIL֪ͨ </FONT></font><BR>
    <P><$font>Ҫ <b>ʱ</b> ȥĹ. ĵȴֱʼѷ.
       <font color=blue>ɫ</font> ʾü¼ʼȷ, <font color=red>ɫ</font> ʾü¼ʼʧ.</font>
    <p><$font>̿ʼ [$date][$time]...<BR>
 |;	

                 open (DB, "<$db_file_name") or &cgierr("error in records. unable to open db file: $db_file_name. Reason: $!");
 	         @lines = <DB>;
    	         close DB;		

		LINE: foreach $line (@lines)
                  {
		     if ($line =~ /^$/) { next LINE; }
		     if ($line =~ /^#/) { $output .= $line; next LINE; }
		     chomp ($line);			
		     (@rec) = &split_decode($line);
		     if ($email_list{$rec[0]}) 
                      {  
                        if(   (length($rec[$db_contact_email]) < 5)  ||  #  an e-mail address must have more than 4 chars to be emailed
                              (length($rec[$db_contact_name]) < 3 )  ||  #  a name  must have more than 2 chars to be emailed
                              ($rec[$db_promotion] =~ /^No/)    )        #  a record must have $db_promotion switch ON to be emailed
                                                                           # You can add this feature by your own so people can decide 
                                                                           # to recieve or recieve NOT your bulk emails. 
                                                                           # to do that just add a files named isPromotion and make it 
                                                                           # works just like "isPop"; then let users see this variable 
                                                                           # and modify it during the "add" and "modify resource" filling 
                                                                           # procedure. 
                          {  
                            if ($in{'is_debug'} ne "yes") 
                               {  print  "<font color=red>$rec[0] ($rec[$db_contact_email])</font><BR>"; 
                                  $errstr .= "$rec[0] ";
                               }
                               else 
                               {  print  "<hr><font color=red>$rec[0]</font>\n\n "; }
                          }

                         else 
                          {
                            $message_to_email_tmp = $in{'message_to_email_body'};

                                 $message_to_email_tmp =~ s/%%ID%%/$rec[0]/mig;
                                 $message_to_email_tmp =~ s/%%category%%/$rec[$db_category]/mig;
                                 $message_to_email_tmp =~ s/%%modified%%/$rec[$db_modified]/mig;
                                 $message_to_email_tmp =~ s/%%url%%/$rec[$db_url]/mig;
                                 $message_to_email_tmp =~ s/%%hits%%/$rec[$db_hits]/mig;
                                 $message_to_email_tmp =~ s/%%isnew%%/$rec[$db_isnew]/mig;
                                 $message_to_email_tmp =~ s/%%ispop%%/$rec[$db_ispop]/mig;
                                 $message_to_email_tmp =~ s/%%contact_name%%/$rec[$db_contact_name]/mig;
                                 $message_to_email_tmp =~ s/%%contact_email%%/$rec[$db_contact_email]/mig;

                             if ($in{'is_debug'} ne "yes") 
                                { print qq|<font color=blue>$rec[0] ($rec[$db_contact_email]) 
				           $rec[$db_contact_name] - $rec[$db_url]</font><BR>
 				          |;
                                  sleep 1 ;
if ($db_use_sockets) {
###################################
# <--BEGIN SMTP SOCKET SECTION -->#
###################################
($x,$x,$x,$x, $here) = gethostbyname($void);
($x,$x,$x,$x, $there) = gethostbyname($def_smtp_server);
$myserver = pack('S n a4 x8',2,0,$here);
$sendserver = pack('S n a4 x8',2,25,$there);
####
#NOTE, if Solaris, uncomment the line below and delete the one below it...leave alone for NT
#and most UNIX systems
#(!(socket(S,2,2,6))) && (&cgierr('Connect error!'));
####
(!(socket(S,2,1,6))) && (&cgierr('Connect error!'));

(!(bind(S,$myserver))) && (&cgierr('Connect error!'));
(!(connect(S,$sendserver))) && (&cgierr("!! connection to $def_smtp_server has failed!"));

select(S); 
$| = 1; 
select(STDOUT);

$DATA_IN = <S>;	
($DATA_IN !~ /^220/) && (&cgierr('Connect error - aborted')); 
#>>>>>>
print S "HELO tg\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Connect error - aborted')); 
#<<<<<<<<
print S "MAIL FROM:<$in{$db_cols[$db_contact_email]}>\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr("'From' address not valid")); 
#<<<<<<<<<<<<<<<
print S "RCPT TO:<$db_admin_email>\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Recipient address not valid')); 
#<<<<<<<<<<<<<<<
print S "DATA\n";
$DATA_IN = <S>;
($DATA_IN !~ /^354/) && (&cgierr('Message send failed - try again')); 
#<<<<<<<<<<<<<<<

print S <<EOF;
From: $db_admin_email
To: $rec[$db_contact_name] <$rec[$db_contact_email]>
Subject: $in{'message_to_email_subject'}

$message_to_email_tmp
.
.
EOF

$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Message send failed - try again')); 
print S "QUIT\n";

#<<<<<<<<<<<<<<<
####################################
#  <--END SMTP SOCKET SECTION -->  #
####################################
}
else
{
                                  open (MAIL, "|$db_mail_path") or &cgierr ("unable to open mail: $db_mail_path. Reason: $!");
                        	  print MAIL "To: $rec[$db_contact_name] <$rec[$db_contact_email]>\n";
                           	  print MAIL "From: $db_admin_email\n";
                        	  print MAIL "Subject: $in{'message_to_email_subject'}\n\n"; 
                	          print MAIL $message_to_email_tmp;
				  print MAIL "\cZ" if ($db_sendmail eq "win");   # ǽţʹãʹWIN -SendMailһֱ
                                  close (MAIL);
}
                                }
                              else 
                                  { print "<hr><PRE><font color=black SIZE=1>$message_to_email_tmp</font></pre>\n\n";   
                                  }

                            $succstr .= "$rec[0] ";
                         } 

                     } # end of if ($email_list{$rec[0]}) 
	          } # end of LINE: foreach $line (@lines)
                }


$time = &get_time; 
$date = &get_date;


if ($db_use_sockets) {
###################################
# <--BEGIN SMTP SOCKET SECTION -->#
###################################
($x,$x,$x,$x, $here) = gethostbyname($void);
($x,$x,$x,$x, $there) = gethostbyname($def_smtp_server);
$myserver = pack('S n a4 x8',2,0,$here);
$sendserver = pack('S n a4 x8',2,25,$there);
####
#NOTE, if Solaris, uncomment the line below and delete the one below it...leave alone for NT
#and most UNIX systems
#(!(socket(S,2,2,6))) && (&cgierr('Connect error!'));
####
(!(socket(S,2,1,6))) && (&cgierr('Connect error!'));

(!(bind(S,$myserver))) && (&cgierr('Connect error!'));
(!(connect(S,$sendserver))) && (&cgierr("!! connection to $def_smtp_server has failed!"));

select(S); 
$| = 1; 
select(STDOUT);

$DATA_IN = <S>;	
($DATA_IN !~ /^220/) && (&cgierr('Connect error - aborted')); 
#>>>>>>
print S "HELO tg\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Connect error - aborted')); 
#<<<<<<<<
print S "MAIL FROM:<$in{$db_cols[$db_contact_email]}>\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr("'From' address not valid")); 
#<<<<<<<<<<<<<<<
print S "RCPT TO:<$db_admin_email>\n";
$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Recipient address not valid')); 
#<<<<<<<<<<<<<<<
print S "DATA\n";
$DATA_IN = <S>;
($DATA_IN !~ /^354/) && (&cgierr('Message send failed - try again')); 
#<<<<<<<<<<<<<<<

if ($in{'is_debug'} eq "yes") {
print S <<EOF;
From: ڴ <$db_admin_email>
To: $db_admin_email
Subject: ڴ־

ڴʼ־
---------------------------------------------

ģʽ - ûʼ -

.
.
EOF
}
else
{
print S <<EOF;
From: ڴ <$db_admin_email>
To: $db_admin_email
Subject: ڴ־
          
ڴʼ־
---------------------------------------------

ڴɹʼ¼¼: $succstr
---------------------------------------------
ܷʼ¼¼: $errstr
---------------------------------------------

:
---------------------------------------------
$in{'message_to_email_body'}
---------------------------------------------

Զ:  $ENV{'REMOTE_HOST'}
ʱ  :  [$date]  -  [$time]

----
.
.
EOF
}

$DATA_IN = <S>;
($DATA_IN !~ /^250/) && (&cgierr('Message send failed - try again')); 
print S "QUIT\n";

#<<<<<<<<<<<<<<<
####################################
#  <--END SMTP SOCKET SECTION -->  #
####################################
}
else
{
open (MAIL, "|$db_mail_path") or &cgierr ("unable to open mail: $db_mail_path. Reason: $!");
       	  print MAIL "To: $db_admin_email\n"; 
       	  print MAIL "From: ڴ <$db_admin_email>\n";
          print MAIL "Subject: ڴ־\n\n"; 
          print MAIL qq|
ڴʼ־
---------------------------------------------
|;
          print MAIL qq|
ģʽ - ûзʼ -
|   if ($in{'is_debug'} eq "yes"); 
 
          print MAIL qq|

ڴɹʼ¼¼: $succstr
---------------------------------------------
ܷʼ¼¼: $errstr
---------------------------------------------

:
---------------------------------------------
$in{'message_to_email_body'}
---------------------------------------------

Զ:  $ENV{'REMOTE_HOST'}
ʱ  :  [$date]  -  [$time]

----
|;
print MAIL "\cZ" if ($db_sendmail eq "win");   # ǽţʹãʹWIN -SendMailһֱ

close (MAIL);
}

print qq|
<hr>
<$font>ʼ־Ѽĸ˹Ա.</font>
|;

print qq|
<p><$font>ȫ! [$time]
<p><font color="red"><b>!</b></font> ʱʼ͵Ľ! 
ǿҽ鵱һκδʱ <B>رյǰ</B> .<BR> 
ȡղѡļ¼밴BACKظղŵıȥв.
</font>
<p>
    <center><$font><a href="http://oh.yeah.net" target="_"><b>Oh Yeah Net</b></a></font></center>
</BODY>
</HTML>
|;



}
